diff --git a/.travis.yml b/.travis.yml
index 7cbfab232a..f793aa494f 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -44,6 +44,7 @@ addons:
       - gdb
       - valgrind
       - python3-docutils
+      - sudo
 
 env:
   - TARGET=Unix
diff --git a/Tmain/unreadable-input.d/input-1.c b/Tmain/unreadable-input.d/input-1.c
new file mode 100644
index 0000000000..c536f0b878
--- /dev/null
+++ b/Tmain/unreadable-input.d/input-1.c
@@ -0,0 +1 @@
+int v1;
diff --git a/Tmain/unreadable-input.d/run.sh b/Tmain/unreadable-input.d/run.sh
new file mode 100644
index 0000000000..9781057ea4
--- /dev/null
+++ b/Tmain/unreadable-input.d/run.sh
@@ -0,0 +1,27 @@
+#!/bin/sh
+
+# Copyright: 2020 Masatake YAMATO
+# License: GPL-2
+
+CTAGS=$1
+
+. ../utils.sh
+
+echo "int v0;" > input-0.c
+chmod a-r input-0.c
+if sudo -u '#1' test -r input-0.c; then
+	skip "sudo neededin this test case doesn't work expectedly on this platform"
+fi
+
+{
+	echo input-0.c
+	echo input-1.c
+} | {
+	if [ $(id -u) = 0 ]; then
+		# The root can read a file even we did "chmod a-r".
+		sudo -u '#1' $CTAGS --quiet --options=NONE -L - -o -
+	else
+		$CTAGS --quiet --options=NONE -L - -o -
+	fi
+}
+rm input-0.c
diff --git a/Tmain/unreadable-input.d/stderr-expected.txt b/Tmain/unreadable-input.d/stderr-expected.txt
new file mode 100644
index 0000000000..732a03ccb8
--- /dev/null
+++ b/Tmain/unreadable-input.d/stderr-expected.txt
@@ -0,0 +1 @@
+ctags: Warning: cannot open "input-0.c" : Permission denied
diff --git a/Tmain/unreadable-input.d/stdout-expected.txt b/Tmain/unreadable-input.d/stdout-expected.txt
new file mode 100644
index 0000000000..9b6a39c989
--- /dev/null
+++ b/Tmain/unreadable-input.d/stdout-expected.txt
@@ -0,0 +1 @@
+v1	input-1.c	/^int v1;$/;"	v	typeref:typename:int
diff --git a/circle.yml b/circle.yml
index 5b377b5b55..606c5f9195 100644
--- a/circle.yml
+++ b/circle.yml
@@ -21,7 +21,7 @@ jobs:
        - run:
            name: Install build tools
            command: |
-             dnf -y install gcc automake autoconf pkgconfig make libseccomp-devel libxml2-devel jansson-devel libyaml-devel findutils diffutils
+             dnf -y install gcc automake autoconf pkgconfig make libseccomp-devel libxml2-devel jansson-devel libyaml-devel findutils diffutils sudo
              dnf -y install jq puppet
        - run:
            name: Build
@@ -59,7 +59,7 @@ jobs:
        - run:
            name: Install build tools
            command: |
-             dnf -y install gcc automake autoconf pkgconfig bmake libseccomp-devel libxml2-devel jansson-devel libyaml-devel findutils
+             dnf -y install gcc automake autoconf pkgconfig bmake libseccomp-devel libxml2-devel jansson-devel libyaml-devel findutils sudo
              dnf -y install jq puppet
        - run:
            name: Build
@@ -85,7 +85,7 @@ jobs:
        - run:
            name: Install build tools
            command: |
-             dnf -y install gcc automake autoconf pkgconfig make libseccomp-devel libxml2-devel jansson-devel libyaml-devel findutils diffutils
+             dnf -y install gcc automake autoconf pkgconfig make libseccomp-devel libxml2-devel jansson-devel libyaml-devel findutils diffutils sudo
              dnf -y install jq puppet
        - run:
            name: Build
@@ -110,7 +110,7 @@ jobs:
        - run:
            name: Install build tools
            command: |
-              yum -y --enablerepo=PowerTools install python3 gcc automake autoconf pkgconfig make libxml2-devel jansson-devel libyaml-devel findutils diffutils
+              yum -y --enablerepo=PowerTools install python3 gcc automake autoconf pkgconfig make libxml2-devel jansson-devel libyaml-devel findutils diffutils sudo
        - run:
            name: Build
            command: |
diff --git a/main/parse.c b/main/parse.c
index cff1a548fa..585273a938 100644
--- a/main/parse.c
+++ b/main/parse.c
@@ -3890,7 +3890,7 @@ extern bool runParserInNarrowedInputStream (const langType language,
 
 static bool createTagsWithFallback (
 	const char *const fileName, const langType language,
-	MIO *mio)
+	MIO *mio, bool *failureInOpenning)
 {
 	langType exclusive_subparser = LANG_IGNORE;
 	bool tagFileResized = false;
@@ -3898,7 +3898,13 @@ static bool createTagsWithFallback (
 	Assert (0 <= language  &&  language < (int) LanguageCount);
 
 	if (!openInputFile (fileName, language, mio))
+	{
+		if (failureInOpenning)
+			*failureInOpenning = true;
 		return false;
+	}
+	if (failureInOpenning)
+		*failureInOpenning = false;
 
 	tagFileResized = createTagsWithFallback1 (language,
 											  &exclusive_subparser);
@@ -4054,6 +4060,7 @@ static bool parseMio (const char *const fileName, langType language, MIO* mio, b
 					  void *clientData)
 {
 	bool tagFileResized = false;
+	bool failureInOpenning = false;
 
 	setupWriter (clientData);
 
@@ -4061,13 +4068,13 @@ static bool parseMio (const char *const fileName, langType language, MIO* mio, b
 
 	initParserTrashBox ();
 
-	tagFileResized = createTagsWithFallback (fileName, language, mio);
+	tagFileResized = createTagsWithFallback (fileName, language, mio, &failureInOpenning);
 
 	finiParserTrashBox ();
 
 	teardownAnon ();
 
-	if (useSourceFileTagPath)
+	if (useSourceFileTagPath && (!failureInOpenning))
 		return teardownWriter (getSourceFileTagPath())? true: tagFileResized;
 	else
 		return teardownWriter(fileName);
